/***********************************************
 * Licensed Materials - Property of IBM
 * 
 * 5724-R31, 5655-S30
 * 
 * (C) Copyright IBM Corp. 2010 All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ***********************************************
 */

package com.ibm.websphere.icp.banking.nao.mock;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import commonj.sdo.DataObject;

import com.ibm.websphere.fabric.industry.support.util.IndustrySupportUtil;
import com.ibm.websphere.sca.ServiceManager;

public class CreateOrUpdateCustomerFileImpl {
    /**
     * Default constructor.
     */
    public CreateOrUpdateCustomerFileImpl() {
        super();
    }

    private static final String CREATE_UPDATE_CUST_FILE_NS = "http://www.ibm.com/xmlns/prod/websphere/icp/2009/12/banking/schema/ifw/81/extn/schema/ArrangementSetup";
    
    private static final Log _log = LogFactory.getLog(CreateOrUpdateCustomerFileImpl.class);
    
    /**
     * Return a reference to the component service instance for this implementation
     * class.  This method should be used when passing this service to a partner reference
     * or if you want to invoke this component service asynchronously.    
     *
     * @generated (com.ibm.wbit.java)
     */
    @SuppressWarnings("unused")
    private Object getMyService() {
        return (Object) ServiceManager.INSTANCE.locateService("self");
    }

    /**
     * Method generated to support implementation of operation "modifyProductArrangement" defined for WSDL port type 
     * named "ModifyProductArrangementPT".
     * 
     * The presence of commonj.sdo.DataObject as the return type and/or as a parameter 
     * type conveys that it is a complex type. Please refer to the WSDL Definition for more information 
     * on the type of input, output and fault(s).
     */
    public DataObject modifyProductArrangement(DataObject aModifyProductArrangementRequest) {
        _log.info("Inside modifyProductArrangement operation of CreateOrUpdateCustomerFileImpl");
        
        DataObject responseDO = IndustrySupportUtil.createDO(CREATE_UPDATE_CUST_FILE_NS, "ModifyProductArrangementResponse");
        
        return responseDO;
    }

}