/***********************************************
 * Licensed Materials - Property of IBM
 * 
 * 5724-R31, 5655-S30
 * 
 * (C) Copyright IBM Corp. 2010 All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ***********************************************
 */
/***********************************************
 * Licensed Materials - Property of IBM
 * 
 * 5724-R31, 5655-S30
 *
 * (C) Copyright IBM Corp. 2010 All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ***********************************************
 */

package com.ibm.websphere.icp.banking.nao.mock;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.apache.commons.lang.StringUtils;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import com.ibm.websphere.fabric.industry.support.util.IndustrySupportUtil;
import com.ibm.websphere.icp.banking.nao.entity.Customer;
import com.ibm.websphere.icp.banking.nao.entity.Postaladdress;
import com.ibm.websphere.icp.industry.db.entities.BaseObject;
import com.ibm.websphere.icp.industry.db.manager.IWicpDBManager;
import com.ibm.websphere.sca.ServiceManager;
import commonj.sdo.DataObject;

public class EnsureKYCImpl {
	/**
	 * Default constructor.
	 */
	public EnsureKYCImpl() {
		super();
	}

	private static final String CHARACTER_EVAL_NS = "http://www.ibm.com/xmlns/prod/websphere/icp/2009/12/banking/schema/ifw/81/extn/schema/CharacterEvaluation";

	private static Log _log = LogFactory.getLog(EnsureKYCImpl.class);

	/**
	 * Return a reference to the component service instance for this
	 * implementation class. This method should be used when passing this
	 * service to a partner reference or if you want to invoke this component
	 * service asynchronously.
	 * 
	 * @generated (com.ibm.wbit.java)
	 */
	@SuppressWarnings("unused")
	private Object getMyService() {
		return (Object) ServiceManager.INSTANCE.locateService("self");
	}

	/**
	 * Method generated to support implementation of operation
	 * "verifyInvolvedPartyDetails" defined for WSDL port type named
	 * "VerifyInvolvedPartyDetailsPT".
	 * 
	 * The presence of commonj.sdo.DataObject as the return type and/or as a
	 * parameter type conveys that it is a complex type. Please refer to the
	 * WSDL Definition for more information on the type of input, output and
	 * fault(s).
	 */
	public DataObject verifyInvolvedPartyDetails(
			DataObject aVerifyInvolvedPartyDetailsRequest) {

		_log
				.info("Inside verifyInvolvedPartyDetails operation of EnsureKYCImpl");

		DataObject involvedPartyIdentifier = aVerifyInvolvedPartyDetailsRequest
				.getDataObject("involvedPartyIdentifier");
		String involvedPartyId = null;
		if (involvedPartyIdentifier != null) {
			involvedPartyId = involvedPartyIdentifier.getString("objectId");
		}

		NAOUtility utility = NAOUtility.getInstance();
		IWicpDBManager dbManager = NAOUtility.getNaoDBManager();

		Map<String, Object> params = new HashMap<String, Object>();
		params.put("customerId", Integer.parseInt(involvedPartyId));
		List<BaseObject> customers = dbManager.executeNamedQuery(
				"findCustomerById", params);

		boolean verified = true;

		if (customers != null && !customers.isEmpty()) {
			// expecting only one instance
			Customer customer = (Customer) customers.get(0);

			Postaladdress postaladdress = customer.getPostaladdressId();
			String postalCode = null;
			if (postaladdress != null) {
				postalCode = postaladdress.getPostalcode().trim();
				//System.out.println("PostalCode:" + postalCode);
			}

			// initializing to KYC Norm fail postal code
			int postalCodeIntValue = 78759;
			if (StringUtils.isNotEmpty(postalCode)) {

				if (StringUtils.isNumeric(postalCode)) {
					postalCodeIntValue = Integer.parseInt(postalCode);
					if (postalCodeIntValue >= 78759
							&& postalCodeIntValue <= 78780) {
						verified = false;
					}
				}

			}

		}

		DataObject responseDO = IndustrySupportUtil.createDO(CHARACTER_EVAL_NS,
				"VerifyInvolvedPartyDetailsResponse");
		responseDO.setBoolean("isVerified", verified);
		return responseDO;
	}
}
