/***********************************************
 * Licensed Materials - Property of IBM
 * 
 * 5724-R31, 5655-S30
 * 
 * (C) Copyright IBM Corp. 2010 All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ***********************************************
 */

package com.ibm.websphere.icp.banking.nao.mock;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import com.ibm.websphere.fabric.industry.support.util.IndustrySupportUtil;
import com.ibm.websphere.sca.ServiceManager;
import commonj.sdo.DataObject;

public class NotifyCustomerImpl {
	/**
	 * Default constructor.
	 */
	public NotifyCustomerImpl() {
		super();
	}

	private static final String NOTIFY_CUSTOMER_NS = "http://www.ibm.com/industries/financialservices";

	private static Log _log = LogFactory.getLog(NotifyCustomerImpl.class);

	/**
	 * Return a reference to the component service instance for this
	 * implementation class. This method should be used when passing this
	 * service to a partner reference or if you want to invoke this component
	 * service asynchronously.
	 * 
	 * @generated (com.ibm.wbit.java)
	 */
	@SuppressWarnings("unused")
	private Object getMyService() {
		return (Object) ServiceManager.INSTANCE.locateService("self");
	}

	/**
	 * Method generated to support implementation of operation
	 * "sendCommunication" defined for WSDL port type named
	 * "CommunicationDispatch".
	 * 
	 * The presence of commonj.sdo.DataObject as the return type and/or as a
	 * parameter type conveys that it is a complex type. Please refer to the
	 * WSDL Definition for more information on the type of input, output and
	 * fault(s).
	 */
	public DataObject sendCommunication(DataObject aSendCommunicationRequest) {
		_log.info("Inside sendCommunication operation of NotifyCustomerImpl");
		String message = ((DataObject) aSendCommunicationRequest.getDataObject(
				"communication").getList("communicationContent").get(0))
				.getString("message");
		_log.info("message:" + message);

		DataObject responseDO = IndustrySupportUtil.createDO(NOTIFY_CUSTOMER_NS,
				"SendCommunicationResponse");
		return responseDO;
	}
}