/***********************************************
 * Licensed Materials - Property of IBM
 * 
 * 5724-R31, 5655-S30
 * 
 * (C) Copyright IBM Corp. 2010 All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ***********************************************
 */

package com.ibm.websphere.icp.banking.nao.mock;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import com.ibm.websphere.fabric.industry.support.util.IndustrySupportUtil;
import com.ibm.websphere.icp.banking.nao.entity.Customer;
import com.ibm.websphere.icp.industry.db.manager.IWicpDBManager;
import com.ibm.websphere.sca.ServiceManager;
import commonj.sdo.DataObject;

public class RecordCustomerDetailsImpl {
    /**
     * Default constructor.
     */
    public RecordCustomerDetailsImpl() {
        super();
    }


    private static final String RECORD_CUST_DTLS_NS = "http://www.ibm.com/industries/financialservices";
    
    private static final Log _log = LogFactory.getLog(RecordCustomerDetailsImpl.class);
    
    /**
     * Return a reference to the component service instance for this implementation
     * class.  This method should be used when passing this service to a partner reference
     * or if you want to invoke this component service asynchronously.    
     *
     * @generated (com.ibm.wbit.java)
     */
    @SuppressWarnings("unused")
    private Object getMyService() {
        return (Object) ServiceManager.INSTANCE.locateService("self");
    }

    /**
     * Method generated to support implementation of operation "recordCustomerDetails" defined for WSDL port type 
     * named "RecordCustomerDetailsPT".
     * 
     * The presence of commonj.sdo.DataObject as the return type and/or as a parameter 
     * type conveys that it is a complex type. Please refer to the WSDL Definition for more information 
     * on the type of input, output and fault(s).
     */
    public DataObject recordCustomerDetails(DataObject aRecordCustomerDetailsRequest) {
        
        _log.info("Inside recordCusotmerDetails operation of RecordCustomerDetailsImpl");
        
        DataObject responseBO = IndustrySupportUtil.createDO(RECORD_CUST_DTLS_NS, "RecordCustomerDetailsResponse");
        DataObject responseHeader = responseBO.createDataObject("responseHeader");
        
        if (aRecordCustomerDetailsRequest != null) {
            DataObject customerBO = aRecordCustomerDetailsRequest.getDataObject("customer");
            if (customerBO != null) {
                
                NAOUtility utility = NAOUtility.getInstance();
                IWicpDBManager dbManager = NAOUtility.getNaoDBManager();
                Customer customer = utility.createCustomerEntity(customerBO);
                if (customer != null) {
                    dbManager.save(customer);
                    
                    //update customer id in the response header
                    String customerId = String.valueOf(customer.getCustomerId());
                    responseHeader.setString("id", customerId);
                }
            }
        }
        return responseBO;
    }

}