/***********************************************
 * Licensed Materials - Property of IBM
 * 
 * 5724-R31, 5655-S30
 * 
 * (C) Copyright IBM Corp. 2010 All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ***********************************************
 */
/**
 * Copyright IBM Corp. 2009, 2010
 */
package com.ibm.websphere.ilog.nao.test;

import org.junit.Test;

public class InvokeJRulesTest {

    @Test
    public void invokeByNewCustomerIsCitezen() throws Exception {
        JRulesRunner.executeEngine("ruleArchive1.jar", "data/request_citizen_pr_new_customer_apply_Checking.xml",
                "data/response_citizen_pr_new_customer_apply_checking.xml");

        JRulesRunner.executeEngine("ruleArchive1.jar", "data/request_citizen_pr_new_customer_apply_CD.xml",
                "data/response_citizen_pr_new_customer_apply_CD.xml");
    }

    @Test
    public void invokeByExistedCustomerIsCitezen() throws Exception {
        JRulesRunner.executeEngine("ruleArchive1.jar", "data/request_citizen_pr_existed_customer_apply_Checking.xml",
                "data/response_citizen_pr_existed_customer_apply_checking.xml");

        JRulesRunner.executeEngine("ruleArchive1.jar", "data/request_citizen_pr_existed_customer_apply_Saving.xml",
                "data/response_citizen_pr_existed_customer_apply_Saving.xml");
    }

    @Test
    public void invokeByNewCustomerIsTempResident() throws Exception {
        JRulesRunner.executeEngine("ruleArchive1.jar", "data/request_temp_resident_new_customer_apply_Saving.xml",
                "data/response_temp_resident_new_customer_apply_Saving.xml");

        JRulesRunner.executeEngine("ruleArchive1.jar", "data/request_temp_resident_new_customer_apply_CD.xml",
                "data/response_temp_resident_new_customer_apply_CD.xml");
    }

    @Test
    public void invokeByExistedCustomerIsTempResident() throws Exception {
        JRulesRunner.executeEngine("ruleArchive1.jar", "data/request_temp_resident_existed_customer_apply_CD.xml",
                "data/response_temp_resident_existed_customer_apply_CD.xml");

        JRulesRunner.executeEngine("ruleArchive1.jar",
                "data/request_temp_resident_existed_customer_apply_Checking.xml",
                "data/response_temp_resident_existed_customer_apply_Checking.xml");
    }

}
