/***********************************************
 * Licensed Materials - Property of IBM
 * 
 * 5724-R31, 5655-S30
 * 
 * (C) Copyright IBM Corp. 2010 All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ***********************************************
 */
/**
 * Copyright IBM Corp. 2009, 2010
 */
package com.ibm.websphere.ilog.nao.test;

import java.io.BufferedReader;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.FileReader;
import java.io.IOException;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.OutputKeys;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.TransformerFactoryConfigurationError;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
import javax.xml.xpath.XPath;
import javax.xml.xpath.XPathConstants;
import javax.xml.xpath.XPathExpressionException;
import javax.xml.xpath.XPathFactory;

import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

public class XMLUtility {

    public static String getXMLContent(String filePath) throws Exception {
        BufferedReader brreader = new BufferedReader(new FileReader(filePath));
        StringBuffer content = new StringBuffer();
        while (brreader.readLine() != null) {
            content.append(brreader.readLine());
        }
        return content.toString();
    }

    public static String getXmlByXpath(String xml, String xpath) throws ParserConfigurationException, SAXException,
            IOException, TransformerException {

        DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
        DocumentBuilder db = dbf.newDocumentBuilder();
        Document doc = db.parse(new ByteArrayInputStream(xml.getBytes()));

        try {
            XPathFactory factory = XPathFactory.newInstance();
            XPath path = factory.newXPath();
            String nodexml = "";
            NodeList results = (NodeList) path.evaluate(xpath, doc, XPathConstants.NODESET);
            for (int i = 0; i < results.getLength(); i++) {
                Node node = results.item(i);

                try {
                    nodexml = covertNodeToString(node);
                    break;
                } catch (TransformerFactoryConfigurationError e) {
                    throw new TransformerException("TransformerFactoryConfigurationError" + e.getMessage());
                } catch (TransformerException e) {
                    throw new TransformerException("TransformerException" + e.getMessage());
                }

            }

            return nodexml;

        } catch (XPathExpressionException e) {
            throw new TransformerException("XPathExpressionException" + e.getMessage());
        }

    }

    public static String covertNodeToString(Node node) throws TransformerFactoryConfigurationError,
            TransformerException {
        Transformer transformer = TransformerFactory.newInstance().newTransformer();
        transformer.setOutputProperty(OutputKeys.INDENT, "yes");
        DOMSource source = new DOMSource(node);
        ByteArrayOutputStream baos = new ByteArrayOutputStream();
        transformer.transform(source, new StreamResult(baos));
        return String.valueOf(baos);
    }

}
