/***********************************************
 * Licensed Materials - Property of IBM
 * 
 * 5724-R31, 5655-S30
 * 
 * (C) Copyright IBM Corp. 2010 All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ***********************************************
 */

package com.ibm.websphere.icp.banking.nao.entity;

import java.io.Serializable;

import javax.persistence.CascadeType;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;

@Entity
public class Arrangementdocuments extends BankingBaseObject implements Serializable {
	@EmbeddedId
	private ArrangementdocumentsPK pk;

	private String document;

	@ManyToOne (cascade={CascadeType.ALL}, fetch=FetchType.EAGER)
	@JoinColumn(name="ARRANGEMENT_ID")
	private Arrangement arrangementId;

	private static final long serialVersionUID = 1L;

	public Arrangementdocuments() {
		super();
	}

	public ArrangementdocumentsPK getPk() {
		return this.pk;
	}

	public void setPk(ArrangementdocumentsPK pk) {
		this.pk = pk;
	}

	public String getDocument() {
		return (this.document != null) ? this.document.trim() : this.document;
	}

	public void setDocument(String document) {
		this.document = (document != null) ? document.trim() : document;
	}

	public Arrangement getArrangementId() {
		return this.arrangementId;
	}

	public void setArrangementId(Arrangement arrangementId) {
		this.arrangementId = arrangementId;
	}

}
