/***********************************************
 * Licensed Materials - Property of IBM
 * 
 * 5724-R31, 5655-S30
 * 
 * (C) Copyright IBM Corp. 2010 All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ***********************************************
 */

package com.ibm.websphere.icp.banking.nao.entity;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;

@Entity
public class Contactdetails extends BankingBaseObject implements Serializable {
	@Id
	@GeneratedValue (strategy=GenerationType.IDENTITY)
	@Column(name="CONTACTDETAILS_ID")
	private int contactdetailsId;

	private String homephonenumber;

	private String mobile;

	private String email;

	private String preferredlanguage;

	private String preferredmedium;

	private String preferredtimeperiod;

	@ManyToOne ( fetch=FetchType.EAGER)
	@JoinColumn(name="CUSTOMER_ID")
	private Customer customerId;

	private static final long serialVersionUID = 1L;

	public Contactdetails() {
		super();
	}

	public int getContactdetailsId() {
		return this.contactdetailsId;
	}

	public void setContactdetailsId(int contactdetailsId) {
		this.contactdetailsId = contactdetailsId;
	}

	public String getHomephonenumber() {
		return (this.homephonenumber != null) ? this.homephonenumber.trim() : this.homephonenumber;
	}

	public void setHomephonenumber(String homephonenumber) {
		this.homephonenumber = (homephonenumber != null) ? homephonenumber.trim() : homephonenumber;
	}

	public String getMobile() {
		return (this.mobile != null) ? this.mobile.trim() : this.mobile;
	}

	public void setMobile(String mobile) {
		this.mobile = (mobile != null) ? mobile.trim() : mobile;
	}

	public String getEmail() {
		return (this.email != null) ? this.email.trim() : this.email;
	}

	public void setEmail(String email) {
		this.email = (email != null) ? email.trim() : email;
	}

	public String getPreferredlanguage() {
		return (this.preferredlanguage != null) ? this.preferredlanguage.trim() : this.preferredlanguage;
	}

	public void setPreferredlanguage(String preferredlanguage) {
		this.preferredlanguage = (preferredlanguage != null) ? preferredlanguage.trim() : preferredlanguage;
	}

	public String getPreferredmedium() {
		return (this.preferredmedium != null) ? this.preferredmedium.trim() : this.preferredmedium;
	}

	public void setPreferredmedium(String preferredmedium) {
		this.preferredmedium = (preferredmedium != null) ? preferredmedium.trim() : preferredmedium;
	}

	public String getPreferredtimeperiod() {
		return (this.preferredtimeperiod != null) ? this.preferredtimeperiod.trim() : this.preferredtimeperiod;
	}

	public void setPreferredtimeperiod(String preferredtimeperiod) {
		this.preferredtimeperiod = (preferredtimeperiod != null) ? preferredtimeperiod.trim() : preferredtimeperiod;
	}

	public Customer getCustomerId() {
		return this.customerId;
	}

	public void setCustomerId(Customer customerId) {
		this.customerId = customerId;
	}

}
