/***********************************************
 * Licensed Materials - Property of IBM
 * 
 * 5724-R31, 5655-S30
 * 
 * (C) Copyright IBM Corp. 2010 All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ***********************************************
 */

package com.ibm.websphere.icp.banking.nao.entity;

import java.io.Serializable;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;

@Entity
public class Employmentdetails extends BankingBaseObject implements Serializable {
	@Id
	@GeneratedValue (strategy=GenerationType.IDENTITY)
	@Column(name="EMPLOYMENTDETAILS_ID")
	private int employmentdetailsId;

	private String type;

	private long annualincome;

	private String employername;

	private String position;

	private String homephonenumber;

	private String mobile;

	@ManyToOne (fetch=FetchType.EAGER)
	@JoinColumn(name="CUSTOMER_ID")
	private Customer customerId;

	@ManyToOne (cascade={CascadeType.ALL}, fetch=FetchType.EAGER)
	@JoinColumn(name="POSTALADDRESS_ID")
	private Postaladdress postaladdressId;

	private static final long serialVersionUID = 1L;

	public Employmentdetails() {
		super();
	}

	public int getEmploymentdetailsId() {
		return this.employmentdetailsId;
	}

	public void setEmploymentdetailsId(int employmentdetailsId) {
		this.employmentdetailsId = employmentdetailsId;
	}

	public String getType() {
		return (this.type != null) ? this.type.trim() : this.type;
	}

	public void setType(String type) {
		this.type = (type != null) ? type.trim() : type;
	}

	public long getAnnualincome() {
		return this.annualincome;
	}

	public void setAnnualincome(long annualincome) {
		this.annualincome = annualincome;
	}

	public String getEmployername() {
		return (this.employername != null) ? this.employername.trim() : this.employername;
	}

	public void setEmployername(String employername) {
		this.employername = (employername != null) ? employername.trim() : employername;
	}

	public String getPosition() {
		return (this.position != null) ? this.position.trim() : this.position;
	}

	public void setPosition(String position) {
		this.position = (position != null) ? position.trim() : position;
	}

	public String getHomephonenumber() {
		return (this.homephonenumber != null) ? this.homephonenumber.trim(): this.homephonenumber;
	}

	public void setHomephonenumber(String homephonenumber) {
		this.homephonenumber = (homephonenumber != null) ? homephonenumber.trim() : homephonenumber;
	}

	public String getMobile() {
		return (this.mobile != null) ? this.mobile.trim() : this.mobile;
	}

	public void setMobile(String mobile) {
		this.mobile = (mobile != null) ? mobile.trim() : mobile;
	}

	public Customer getCustomerId() {
		return this.customerId;
	}

	public void setCustomerId(Customer customerId) {
		this.customerId = customerId;
	}

	public Postaladdress getPostaladdressId() {
		return this.postaladdressId;
	}

	public void setPostaladdressId(Postaladdress postaladdressId) {
		this.postaladdressId = postaladdressId;
	}

}
