/***********************************************
 * Licensed Materials - Property of IBM
 * 
 * 5724-R31, 5655-S30
 * 
 * (C) Copyright IBM Corp. 2010 All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ***********************************************
 */

package com.ibm.websphere.icp.banking.nao.entity;

import java.io.Serializable;
import java.util.Set;


import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.OneToMany;

@Entity
public class Postaladdress extends BankingBaseObject implements Serializable {
	@Id
	@GeneratedValue (strategy=GenerationType.IDENTITY)
	@Column(name="POSTALADDRESS_ID")
	private int postaladdressId;

	private String addressline1;

	private String addressline2;

	private String city;

	private String state;

	private String country;

	private String postalcode;

	@OneToMany(mappedBy="postaladdressId", fetch=FetchType.EAGER)
	private Set<Customer> customerCollection;

	@OneToMany(mappedBy="postaladdressId", fetch=FetchType.EAGER)
	private Set<Employmentdetails> employmentdetailsCollection;

	private static final long serialVersionUID = 1L;

	public Postaladdress() {
		super();
	}

	public int getPostaladdressId() {
		return this.postaladdressId;
	}

	public void setPostaladdressId(int postaladdressId) {
		this.postaladdressId = postaladdressId;
	}

	public String getAddressline1() {
		return (this.addressline1 != null) ? this.addressline1.trim() : this.addressline1;
	}

	public void setAddressline1(String addressline1) {
		this.addressline1 = (addressline1 != null) ? addressline1.trim() : addressline1;
	}

	public String getAddressline2() {
		return (this.addressline2 != null) ? this.addressline2.trim() : this.addressline2;
	}

	public void setAddressline2(String addressline2) {
		this.addressline2 = (addressline2 != null) ? addressline2.trim() : addressline2;
	}

	public String getCity() {
		return (this.city != null) ? this.city.trim() : this.city;
	}

	public void setCity(String city) {
		this.city = (city != null) ? city.trim() : city;
	}

	public String getState() {
		return (this.state != null) ? this.state.trim() : this.state;
	}

	public void setState(String state) {
		this.state = (state != null) ? state.trim() : state;
	}

	public String getCountry() {
		return (this.country != null) ? this.country.trim() : this.country;
	}

	public void setCountry(String country) {
		this.country = (country != null) ? country.trim() : country;
	}

	public String getPostalcode() {
		return (this.postalcode != null) ? this.postalcode.trim() : this.postalcode;
	}

	public void setPostalcode(String postalcode) {
		this.postalcode = (postalcode != null) ? postalcode.trim() : postalcode;
	}

	public Set<Customer> getCustomerCollection() {
		return this.customerCollection;
	}

	public void setCustomerCollection(Set<Customer> customerCollection) {
		this.customerCollection = customerCollection;
	}

	public Set<Employmentdetails> getEmploymentdetailsCollection() {
		return this.employmentdetailsCollection;
	}

	public void setEmploymentdetailsCollection(Set<Employmentdetails> employmentdetailsCollection) {
		this.employmentdetailsCollection = employmentdetailsCollection;
	}

}
