/***********************************************
 * Licensed Materials - Property of IBM
 * 
 * 5724-R31, 5655-S30
 * 
 * (C) Copyright IBM Corp. 2010 All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ***********************************************
 */

package com.ibm.websphere.icp.banking.nao.entity;

import java.io.Serializable;


import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;

@Entity
public class Residencedetails extends BankingBaseObject implements Serializable {
	@Id
	@GeneratedValue (strategy=GenerationType.IDENTITY)
	@Column(name="RESIDENCEDETAILS_ID")
	private int residencedetailsId;

	private String country;

	private String years;

	private String status;

	@ManyToOne ( fetch=FetchType.EAGER)
	@JoinColumn(name="CUSTOMER_ID")
	private Customer customerId;

	private static final long serialVersionUID = 1L;

	public Residencedetails() {
		super();
	}

	public int getResidencedetailsId() {
		return this.residencedetailsId;
	}

	public void setResidencedetailsId(int residencedetailsId) {
		this.residencedetailsId = residencedetailsId;
	}

	public String getCountry() {
		return (this.country != null) ? this.country.trim() : this.country;
	}

	public void setCountry(String country) {
		this.country = (country != null) ? country.trim() : country;
	}

	public String getYears() {
		return (this.years != null) ? this.years.trim() : this.years;
	}

	public void setYears(String years) {
		this.years = (years != null) ? years.trim() : years;
	}

	public String getStatus() {
		return (this.status != null) ? this.status.trim() : this.status;
	}

	public void setStatus(String status) {
		this.status = (status != null) ? status.trim() : status;
	}

	public Customer getCustomerId() {
		return this.customerId;
	}

	public void setCustomerId(Customer customerId) {
		this.customerId = customerId;
	}

}
