/***********************************************
 * Licensed Materials - Property of IBM
 * 
 * 5724-R31, 5655-S30
 * 
 * (C) Copyright IBM Corp. 2010 All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ***********************************************
 */

package com.ibm.websphere.icp.banking.nao.entity;

import java.io.Serializable;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;

@Entity
public class Term extends BankingBaseObject implements Serializable {
	@Id
	@GeneratedValue (strategy=GenerationType.IDENTITY)
	@Column(name="TERM_ID")
	private int termId;

	private int years;

	private int months;

	private int days;

	@ManyToOne (cascade={CascadeType.ALL}, fetch=FetchType.EAGER)
	@JoinColumn(name="ARRANGEMENT_ID")
	private Arrangement arrangementId;

	private static final long serialVersionUID = 1L;

	public Term() {
		super();
	}

	public int getTermId() {
		return this.termId;
	}

	public void setTermId(int termId) {
		this.termId = termId;
	}

	public int getYears() {
		return this.years;
	}

	public void setYears(int years) {
		this.years = years;
	}

	public int getMonths() {
		return this.months;
	}

	public void setMonths(int months) {
		this.months = months;
	}

	public int getDays() {
		return this.days;
	}

	public void setDays(int days) {
		this.days = days;
	}

	public Arrangement getArrangementId() {
		return this.arrangementId;
	}

	public void setArrangementId(Arrangement arrangementId) {
		this.arrangementId = arrangementId;
	}

}
