/***********************************************
 * Licensed Materials - Property of IBM
 * 
 * 5724-R31, 5655-S30
 * 
 * (C) Copyright IBM Corp. 2010 All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ***********************************************
 */
package emulation;

import java.io.IOException;
import java.io.InputStream;

import commonj.sdo.DataObject;

import com.ibm.websphere.bo.BOXMLDocument;
import com.ibm.websphere.bo.BOXMLSerializer;
import com.ibm.websphere.sca.ServiceManager;

public class CreateCustomerImpl {
	/**
	 * Default constructor.
	 */
	public CreateCustomerImpl() {
		super();
	}

	/**
	 * Return a reference to the component service instance for this implementation
	 * class.  This method should be used when passing this service to a partner reference
	 * or if you want to invoke this component service asynchronously.    
	 *
	 * @generated (com.ibm.wbit.java)
	 */
	@SuppressWarnings("unused")
	private Object getMyService() {
		return (Object) ServiceManager.INSTANCE.locateService("self");
	}

	/**
	 * Method generated to support implementation of operation "CreateCustomer" defined for WSDL port type 
	 * named "CreateCustomerHT".
	 * 
	 * The presence of commonj.sdo.DataObject as the return type and/or as a parameter 
	 * type conveys that it is a complex type. Please refer to the WSDL Definition for more information 
	 * on the type of input, output and fault(s).
	 */
	public DataObject CreateCustomer(DataObject input) throws IOException {

		InputStream istream = CreateCustomerImpl.class
				.getResourceAsStream("/testdata/CreateNewCustomer.xml");

		BOXMLSerializer boXMLSerializer = (BOXMLSerializer) ServiceManager.INSTANCE
				.locateService("com/ibm/websphere/bo/BOXMLSerializer");

		BOXMLDocument boDoc = boXMLSerializer.readXMLDocument(istream);

		DataObject customerBO = boDoc.getDataObject();

		return customerBO;

	}

}
