/***********************************************
 * Licensed Materials - Property of IBM
 * 
 * 5724-R31, 5655-S30
 * 
 * (C) Copyright IBM Corp. 2010 All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ***********************************************
 */
package emulation;

import java.util.List;
import com.ibm.websphere.sca.ServiceManager;
import commonj.sdo.DataObject;
import java.io.IOException;

public class SelectCustomerImpl {
	/**
	 * Default constructor.
	 */
	public SelectCustomerImpl() {
		super();
	}

	/**
	 * Return a reference to the component service instance for this
	 * implementation class. This method should be used when passing this
	 * service to a partner reference or if you want to invoke this component
	 * service asynchronously.
	 * 
	 * @generated (com.ibm.wbit.java)
	 */
	@SuppressWarnings("unused")
	private Object getMyService() {
		return (Object) ServiceManager.INSTANCE.locateService("self");
	}

	/**
	 * Method generated to support implementation of operation "SelectCustomer"
	 * defined for WSDL port type named "SelectCustomerHT".
	 * 
	 * The presence of commonj.sdo.DataObject as the return type and/or as a
	 * parameter type conveys that it is a complex type. Please refer to the
	 * WSDL Definition for more information on the type of input, output and
	 * fault(s).
	 * 
	 * @throws IOException
	 */
	public DataObject SelectCustomer(DataObject input) throws IOException {
		
		List customerList = input.getList("customer");
		
		if (customerList != null && !customerList.isEmpty()) {
			((DataObject)customerList.get(0)).setBoolean("select", true);
		}
		else {
			input.setBoolean("back", true);
		}
		return input;
	}

}
