--<ScriptOptions statementTerminator=";"/>

CONNECT 'WICPDB;create=true;territory=EN_US' as WICPDB; 

CREATE TABLE BANKING_NAO.RESIDENCEDETAILS (
		RESIDENCEDETAILS_ID INTEGER NOT NULL GENERATED ALWAYS AS IDENTITY  (START WITH 1 ,INCREMENT BY 1),
		COUNTRY VARCHAR(10),
		YEARS VARCHAR(10),
		STATUS VARCHAR(20),
		CUSTOMER_ID INTEGER NOT NULL
	);

CREATE TABLE BANKING_NAO.ARRANGEMENTDOCUMENTS (
		ARRANGEMENT_ID INTEGER NOT NULL,
		ARRANGEMENTDOCUMENTS_ID INTEGER NOT NULL GENERATED ALWAYS AS IDENTITY  (START WITH 1 ,INCREMENT BY 1),
		DOCUMENT VARCHAR(50)
	);

CREATE TABLE BANKING_NAO.CONTACTDETAILS (
		CONTACTDETAILS_ID INTEGER NOT NULL GENERATED ALWAYS AS IDENTITY  (START WITH 1 ,INCREMENT BY 1),
		HOMEPHONENUMBER VARCHAR(20),
		MOBILE VARCHAR(20),
		EMAIL VARCHAR(120),
		PREFERREDLANGUAGE VARCHAR(50),
		PREFERREDMEDIUM VARCHAR(50),
		PREFERREDTIMEPERIOD VARCHAR(120),
		CUSTOMER_ID INTEGER NOT NULL
	);

CREATE TABLE BANKING_NAO.TERM (
		TERM_ID INTEGER NOT NULL GENERATED ALWAYS AS IDENTITY  (START WITH 1 ,INCREMENT BY 1),
		YEARS INTEGER,
		MONTHS INTEGER,
		DAYS INTEGER,
		ARRANGEMENT_ID INTEGER NOT NULL
	);

CREATE TABLE BANKING_NAO.POSTALADDRESS (
		POSTALADDRESS_ID INTEGER NOT NULL GENERATED ALWAYS AS IDENTITY  (START WITH 1 ,INCREMENT BY 1),
		ADDRESSLINE1 CHAR(120),
		ADDRESSLINE2 CHAR(120),
		CITY CHAR(50),
		STATE CHAR(50),
		COUNTRY CHAR(50),
		POSTALCODE CHAR(20)
	);

CREATE TABLE BANKING_NAO.EMPLOYMENTDETAILS (
		EMPLOYMENTDETAILS_ID INTEGER NOT NULL GENERATED ALWAYS AS IDENTITY  (START WITH 1 ,INCREMENT BY 1),
		TYPE VARCHAR(50),
		ANNUALINCOME BIGINT,
		EMPLOYERNAME VARCHAR(200),
		POSITION VARCHAR(120),
		HOMEPHONENUMBER VARCHAR(20),
		MOBILE VARCHAR(20),
		CUSTOMER_ID INTEGER NOT NULL,
		POSTALADDRESS_ID INTEGER
	);

CREATE TABLE BANKING_NAO.CUSTOMER (
		CUSTOMER_ID INTEGER NOT NULL GENERATED ALWAYS AS IDENTITY  (START WITH 10000000 ,INCREMENT BY 1),
		POSTALADDRESS_ID INTEGER,
		DATEOFBIRTH DATE,
		GENDER VARCHAR(20),
		MARITALSTATUS VARCHAR(50),
		SSN VARCHAR(20),
		AGE INTEGER,
		CITIZENSHIPCOUNTRY VARCHAR(20),
		RESIDENCESTATUSOFUS VARCHAR(50),
		RELATIONSHIPMANAGER VARCHAR(120),
		RELATIONSHIPCODE VARCHAR(20),
		CUSTOMERSTATUS VARCHAR(50),
		NEWCUSTOMER CHAR(1),
		LOGINID CHAR(20),
		DESCRIPTION VARCHAR(50),
		ENDDATE DATE,
		NAMETEXT VARCHAR(120),
		STARTDATE DATE,
		TYPE VARCHAR(50),
		FIRSTNAME VARCHAR(50),
		LASTNAME VARCHAR(50),
		MIDDLENAMES VARCHAR(50),
		PREFIXTITLE VARCHAR(10),
		SHORTFIRSTNAME VARCHAR(50),
		SUFFIXTITLE VARCHAR(10)
	);

CREATE TABLE BANKING_NAO.COAPPLICANTS (
		ARRANGEMENT_ID INTEGER NOT NULL,
		CUSTOMER_ID INTEGER NOT NULL
	);

CREATE TABLE BANKING_NAO.ARRANGEMENT (
		ARRANGEMENT_ID INTEGER NOT NULL GENERATED ALWAYS AS IDENTITY  (START WITH 1 ,INCREMENT BY 1),
		DESCRIPTION VARCHAR(200),
		ENDDATE DATE,
		NAME VARCHAR(200),
		STARTDATE DATE,
		LIFECYCLESTATUS VARCHAR(20),
		LIFECYCLEPHASEINITIATION VARCHAR(20),
		APPLICATIONNUMBER VARCHAR(50),
		CURRENCY VARCHAR(10),
		ACCOUNTNUMBER VARCHAR(50),
		ACCOUNTTYPE VARCHAR(50),
		PRODUCT VARCHAR(50),
		CARD VARCHAR(50),
		INTERNETBANKING CHAR(1),
		IVR CHAR(1),
		CHECKBOOK CHAR(1),
		CHECKQUANTITY INTEGER,
		OPERATINGINSTRUCTION VARCHAR(50),
		CUSTOMER_ID INTEGER,
		APPROVEDBY VARCHAR(50),
		DEPOSITDATE DATE,
		STATEMENTTYPE VARCHAR(20),
		STATEMENTFREQUENCY VARCHAR(20)
	);

ALTER TABLE BANKING_NAO.TERM ADD CONSTRAINT TERM_PK PRIMARY KEY (TERM_ID);

ALTER TABLE BANKING_NAO.ARRANGEMENTDOCUMENTS ADD CONSTRAINT ARRANGEMENTDOCUMENTS_PK PRIMARY KEY (ARRANGEMENT_ID, ARRANGEMENTDOCUMENTS_ID);

ALTER TABLE BANKING_NAO.EMPLOYMENTDETAILS ADD CONSTRAINT EMPLOYMENTDETAILS_PK PRIMARY KEY (EMPLOYMENTDETAILS_ID);

ALTER TABLE BANKING_NAO.CONTACTDETAILS ADD CONSTRAINT CONTACTDETAILS_PK PRIMARY KEY (CONTACTDETAILS_ID);

ALTER TABLE BANKING_NAO.POSTALADDRESS ADD CONSTRAINT POSTALADDRESS_PK PRIMARY KEY (POSTALADDRESS_ID);

ALTER TABLE BANKING_NAO.CUSTOMER ADD CONSTRAINT CUSTOMER_PK PRIMARY KEY (CUSTOMER_ID);

ALTER TABLE BANKING_NAO.COAPPLICANTS ADD CONSTRAINT COAPPLICANTS_PK PRIMARY KEY (ARRANGEMENT_ID, CUSTOMER_ID);

ALTER TABLE BANKING_NAO.ARRANGEMENT ADD CONSTRAINT ARRANGEMENT_PK PRIMARY KEY (ARRANGEMENT_ID);

ALTER TABLE BANKING_NAO.RESIDENCEDETAILS ADD CONSTRAINT RESIDENCEDETAILS_PK PRIMARY KEY (RESIDENCEDETAILS_ID);

ALTER TABLE BANKING_NAO.EMPLOYMENTDETAILS ADD CONSTRAINT EMPL_DTLS_ADDR_FK FOREIGN KEY (POSTALADDRESS_ID)
	REFERENCES BANKING_NAO.POSTALADDRESS (POSTALADDRESS_ID);

ALTER TABLE BANKING_NAO.ARRANGEMENT ADD CONSTRAINT ARRG_CUST_FK FOREIGN KEY (CUSTOMER_ID)
	REFERENCES BANKING_NAO.CUSTOMER (CUSTOMER_ID);

ALTER TABLE BANKING_NAO.COAPPLICANTS ADD CONSTRAINT COAPP_ARRG_FK FOREIGN KEY (ARRANGEMENT_ID)
	REFERENCES BANKING_NAO.ARRANGEMENT (ARRANGEMENT_ID);

ALTER TABLE BANKING_NAO.CUSTOMER ADD CONSTRAINT CUST_ADDR_FK FOREIGN KEY (POSTALADDRESS_ID)
	REFERENCES BANKING_NAO.POSTALADDRESS (POSTALADDRESS_ID);

ALTER TABLE BANKING_NAO.RESIDENCEDETAILS ADD CONSTRAINT RES_DTLS_CUST_FK FOREIGN KEY (CUSTOMER_ID)
	REFERENCES BANKING_NAO.CUSTOMER (CUSTOMER_ID);

ALTER TABLE BANKING_NAO.COAPPLICANTS ADD CONSTRAINT COAPP_CUST_FK FOREIGN KEY (CUSTOMER_ID)
	REFERENCES BANKING_NAO.CUSTOMER (CUSTOMER_ID);

ALTER TABLE BANKING_NAO.CONTACTDETAILS ADD CONSTRAINT CONT_DTLS_CUST_FK FOREIGN KEY (CUSTOMER_ID)
	REFERENCES BANKING_NAO.CUSTOMER (CUSTOMER_ID);

ALTER TABLE BANKING_NAO.TERM ADD CONSTRAINT TERM_ARRG_FK FOREIGN KEY (ARRANGEMENT_ID)
	REFERENCES BANKING_NAO.ARRANGEMENT (ARRANGEMENT_ID);

ALTER TABLE BANKING_NAO.ARRANGEMENTDOCUMENTS ADD CONSTRAINT ARRG_DOCS_ARRG_FK FOREIGN KEY (ARRANGEMENT_ID)
	REFERENCES BANKING_NAO.ARRANGEMENT (ARRANGEMENT_ID);

ALTER TABLE BANKING_NAO.EMPLOYMENTDETAILS ADD CONSTRAINT EMPL_DTLS_CUST_FK FOREIGN KEY (CUSTOMER_ID)
	REFERENCES BANKING_NAO.CUSTOMER (CUSTOMER_ID);


-- sample test data for Adam user

-- Address
INSERT INTO BANKING_NAO.POSTALADDRESS
  ( ADDRESSLINE1,
    ADDRESSLINE2,
    CITY,
    STATE,
    COUNTRY,
    POSTALCODE )
  VALUES (
     'Street No. 12',
     'Block No. 3',
     'Austin',
     'TX',
     'US',
     '78760');

INSERT INTO BANKING_NAO.POSTALADDRESS
  ( ADDRESSLINE1,
    ADDRESSLINE2,
    CITY,
    STATE,
    COUNTRY,
    POSTALCODE )
  VALUES (
    'Street No. 23',
     'Block No. 8',
     'Houston',
     'TX',
     'US',
     '77231');

-- Customer
INSERT INTO BANKING_NAO.CUSTOMER 
  ( POSTALADDRESS_ID, 
    DATEOFBIRTH, 
    GENDER, 
    MARITALSTATUS, 
    SSN, 
    CITIZENSHIPCOUNTRY, 
    RESIDENCESTATUSOFUS, 
    RELATIONSHIPMANAGER, 
    RELATIONSHIPCODE, 
    CUSTOMERSTATUS, 
    NEWCUSTOMER, 
    LOGINID, 
    TYPE, 
    FIRSTNAME, 
    LASTNAME, 
    PREFIXTITLE ) 
  VALUES 
  ( 1,
    '1934-02-04',
    'Male',
    'Married',
    '123679982',
    'US',
    'Citizen/PR',
    'Samantha',
    '10098',
    'Platinum',
    'N',
    'Adam',
    NULL,
    'Adam',
    'Smith',
    'mr' );
    
-- Contact Details
INSERT INTO BANKING_NAO.CONTACTDETAILS
  ( HOMEPHONENUMBER,
    MOBILE,
    EMAIL,
    PREFERREDLANGUAGE,
    PREFERREDMEDIUM,
    PREFERREDTIMEPERIOD,
    CUSTOMER_ID )
  VALUES
   ( '(987) 234-9876',
     '9876123498',
     'adam@ibm.com',
     'English',
     'Email',
     '9AM - 6PM',
     10000000 );
     
-- Residence Details
INSERT INTO BANKING_NAO.RESIDENCEDETAILS
  ( COUNTRY,
    YEARS,
    STATUS,
    CUSTOMER_ID )
  VALUES
   ( 'US',
      '20',
      'Resident',
      10000000 );
      
-- Employment Details
INSERT INTO BANKING_NAO.EMPLOYMENTDETAILS
  ( TYPE,
    ANNUALINCOME,
    EMPLOYERNAME,
    POSITION,
    HOMEPHONENUMBER,
    MOBILE,
    CUSTOMER_ID,
    POSTALADDRESS_ID )
  VALUES 
   ( 'Salaried',
     100000,
     'IBM Corporation',
     'Manager',
     '(987) 245-9981',
     '9657765657',
     10000000,
     2);     